module Residue7 (r, ina, inb);
	input  [2:0] ina, inb;
	output [2:0] r;
	wire   a, b, c, d;

	assign #(6,7) {a, b, c, d} = ina + inb;

	assign #(3, 5) r[2] = (b&~c)|(~a&b&~d)|(a&c&d);
	assign #(3, 5) r[1] = (~a&~b&c)|(~a&c&~d)|(~b&c&~d)|(a&~c&d);
	assign #(3, 5) r[0] = (~a&~c&d)|(~a&~b&d)|(a&~c&~d)|(a&~b&~d);
endmodule
